# module wrapper
module JcB
  extend self
  # simple cypher
  ALPHABET = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'.freeze

  # generated with .split('').shuffle.join
  ENCODING = 'MOhqm0PnycUZeLdK8YvDCgNfb7FJtiHT52BrxoAkas9RWlXpEujSGI64VzQ31w'.freeze

  def encode(strng)
    if strng.class == String
      return strng.tr(ALPHABET, ENCODING)
    else
      return strng
    end
  end

  def decode(strng)
    if strng.class == String
      return strng.tr(ENCODING, ALPHABET)
    else
      return strng
    end
  end

  def break_dc
    m = Sketchup.active_model
    m.definitions.each do |d|
    next unless d.attribute_dictionaries && d.attribute_dictionaries['dynamic_attributes']
    d.get_attributes('dynamic_attributes').each do |a|
      d.set_attribute('encrypt_attributes', encode(a[0]), encode(a[1]))
      d.attribute_dictionaries.delete('dynamic_attributes')
    end

    d.instances.each do |i|
    next unless i.attribute_dictionaries && i.attribute_dictionaries['dynamic_attributes']
    i.get_attributes('dynamic_attributes').each do |a|
      i.set_attribute('encrypt_attributes', encode(a[0]), encode(a[1]))
      i.attribute_dictionaries.delete('dynamic_attributes')
    end end end
    m.definitions.purge_unused

    m = Sketchup.active_model
    m.definitions.each do |d|
      next unless d.attribute_dictionaries && d.attribute_dictionaries['encrypt_attributes']
      p d
      d.get_attributes('encrypt_attributes').each do |a|
        p a
      end end
  end

  def fix_dc
    m = Sketchup.active_model
    m.definitions.each do |d|
    next unless d.attribute_dictionaries && d.attribute_dictionaries['encrypt_attributes']
    d.get_attributes('encrypt_attributes').each do |a|
      d.set_attribute('dynamic_attributes', decode(a[0]), decode(a[1]))
      d.attribute_dictionaries.delete('encrypt_attributes')
    end

    d.instances.each do |i|
    next unless i.attribute_dictionaries && i.attribute_dictionaries['encrypt_attributes']
    i.get_attributes('encrypt_attributes').each do |a|
      i.set_attribute('dynamic_attributes', decode(a[0]), decode(a[1]))
      i.attribute_dictionaries.delete('encrypt_attributes')
    end end end
    m.definitions.purge_unused

    m = Sketchup.active_model
    m.definitions.each do |d|
      next unless d.attribute_dictionaries && d.attribute_dictionaries['dynamic_attributes']
      p d
      d.get_attributes('dynamic_attributes').each do |a|
        p a
      end end
  end
end
